/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.niederschrift;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.niederschrift.boundary.AbstractNiederschriftKorrekturSearchParameters;
import de.ivu.elect.business.niederschrift.boundary.NiederschriftKorrekturChangeEvent;
import de.ivu.elect.business.niederschrift.boundary.NiederschriftKorrekturConversationStore;
import de.ivu.elect.business.niederschrift.boundary.NiederschriftKorrekturExtendedDAO;
import de.ivu.elect.business.niederschrift.boundary.NiederschriftKorrekturSearch;
import de.ivu.elect.business.niederschrift.boundary.NiederschriftKorrekturSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.niederschrift.entity.NiederschriftKorrektur;
import de.ivu.elect.business.niederschrift.entity.NiederschriftKorrekturMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractNiederschriftKorrekturSearchView.COMPONENT_NAME)
@View(viewId = AbstractNiederschriftKorrekturSearchView.VIEW_ID, useCase = UseCasePermission.NIEDERSCHRIFT_KORREKTUR_SEARCH)
public abstract class AbstractNiederschriftKorrekturSearchView extends AbstractElectSearchView<NiederschriftKorrektur> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "niederschriftKorrekturSearchView";
  
  public static final String VIEW_ID = "/niederschrift/niederschrift-korrektur-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractNiederschriftKorrekturSearchView requestHandler;

  @Inject
  private transient NiederschriftKorrekturExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(NiederschriftKorrekturConversationStore.class)
  protected transient NiederschriftKorrekturConversationStore conversationStore;

  @Inject
  protected transient NiederschriftKorrekturSearch search;

  @Inject
  @ConversationGroup(AbstractNiederschriftKorrekturSearchParameters.class)
  protected transient NiederschriftKorrekturSearchParameters searchParameters;

  @Inject
  protected transient NiederschriftKorrekturMeta entityMeta;

  public AbstractNiederschriftKorrekturSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public NiederschriftKorrektur getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(NiederschriftKorrektur entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public NiederschriftKorrekturSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<NiederschriftKorrektur> getEagerLoadingCollector() {
    return EagerLoadingCollector.<NiederschriftKorrektur> create();
  }

  @Override
  public List<NiederschriftKorrektur> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<NiederschriftKorrektur> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onNiederschriftKorrekturChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) NiederschriftKorrekturChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractNiederschriftKorrekturSearchView {

    @View
    @Inject
    private transient Instance<AbstractNiederschriftKorrekturSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractNiederschriftKorrekturSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
